﻿<%@ Page Title="" Language="C#" MasterPageFile="~/WebsiteMasterPage.master" AutoEventWireup="true" CodeFile="Sparta_TeachingSchedule.aspx.cs" Inherits="admin_module_Sparta_TeachingSchedule" %>

<asp:Content ID="Content1" ContentPlaceHolderID="headlink" runat="Server">
    <link href="/admin_css/calendar.css" rel="stylesheet" />
    <style>
        .fc-daygrid-event {
            white-space: normal;
        }

        .fc-direction-ltr .fc-daygrid-event.fc-event-end {
            border-radius: 6px;
        }

        .fc .fc-col-header-cell-cushion a {
            color: yellow;
        }

        .fc-button.fc-button-primary {
            font-size: 13px;
        }

        .fc .fc-button .fc-icon {
            font-size: 13px;
            font-weight: 700;
        }

        .fc-direction-ltr .fc-daygrid-event.fc-event-end {
            margin: 3px;
        }

        .fc-button-group .fc-button {
            background-color: #89c99c;
            border-color: #89c99c;
            font-weight: 700;
        }

        .fc .fc-toolbar-title {
            font-weight: 700;
            font-size: 15px;
        }

        .fc-event .fc-event-main {
            margin: 3px;
        }

        .fc .fc-button-primary:not(:disabled).fc-button-active {
            background-color: #1da881;
            border-color: #1da881;
            font-weight: 700;
        }

        .fc .fc-button-primary:hover {
            color: #fff;
            color: let(--fc-button-text-color, #fff);
            background-color: #1da881;
            background-color: let(--fc-button-hover-bg-color, #1da881);
            border-color: #1da881;
            border-color: let(--fc-button-hover-border-color, #1da881);
        }

        .fc-h-event .fc-event-title-container {
            font-size: 13px;
        }

        .fc-event-title.fc-sticky {
            white-space: pre-wrap;
        }
    </style>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="hihead" runat="Server">
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="himenu" runat="Server">
</asp:Content>
<asp:Content ID="Content4" ContentPlaceHolderID="higlobal" runat="Server">
</asp:Content>
<asp:Content ID="Content5" ContentPlaceHolderID="hislider" runat="Server">
</asp:Content>
<asp:Content ID="Content6" ContentPlaceHolderID="hibelowtop" runat="Server">
</asp:Content>
<asp:Content ID="Content7" ContentPlaceHolderID="hibodyhead" runat="Server">
</asp:Content>
<asp:Content ID="Content8" ContentPlaceHolderID="hibodywrapper" runat="Server">
    <script src="/admin_js/fullcalendar-5.5.1.js"></script>
    <script src="/admin_js/fullcalendar-locales-all.js"></script>
    <!-- Content -->
    <div class="content">
        <!-- Animated -->
        <div class="animated fadeIn">
            <!-- Widgets  -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="card">
                        <div class="card-body">
                            <div class="d-flex align-items-center justify-content-between">
                                <%--<h4 class="box-title mb-3">Lịch dạy</h4>--%>
                                <div>
                                    <select id="_listgiaovien" data-placeholder="Chọn giáo viên..." class="standardSelect" tabindex="1">
                                        <option value="" label="default"></option>
                                    </select>
                                </div>
                            </div>

                        </div>

                        <div class="card-body">
                            <div id="calendar">
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </div>

    </div>


    <!-- Add Calendar Form -->
    <div class="modal fade" id="addNewCalendarForm" aria-hidden="true" aria-labelledby="addNewCalendarForm"
        role="dialog" tabindex="-1">
        <div class="modal-dialog modal-simple">
            <form class="modal-content" action="#" method="post" role="form">
                <div class="modal-header">
                    <button type="button" class="close" aria-hidden="true" data-dismiss="modal">×</button>
                    <h4 class="modal-title">Create New Calendar</h4>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label class="form-control-label mb-15" for="name">Calendar name:</label>
                        <input type="text" class="form-control" id="name" name="name" placeholder="Calendar name">
                    </div>
                    <div class="form-group">
                        <label class="form-control-label mb-15" for="name">Choice people to your project:</label>
                        <select multiple="multiple" class="plugin-selective"></select>
                    </div>
                </div>
                <div class="modal-footer">
                    <div class="form-actions">
                        <button class="btn btn-primary" data-dismiss="modal" type="button">Create</button>
                        <a class="btn btn-sm btn-white" data-dismiss="modal" href="javascript:void(0)">Cancel</a>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <!-- End Add Calendar Form -->


</asp:Content>
<asp:Content ID="Content9" ContentPlaceHolderID="hibodybottom" runat="Server">
</asp:Content>
<asp:Content ID="Content10" ContentPlaceHolderID="hibelowbottom" runat="Server">
</asp:Content>
<asp:Content ID="Content11" ContentPlaceHolderID="hifooter" runat="Server">
    <script type="text/javascript">
        jQuery(document).ready(function () {
            jQuery(".standardSelect").chosen({
                disable_search_threshold: 10,
                no_results_text: "Không tìm thấy thông tin !",
                width: "100%"
            });
            loadteachers(jQuery('#sltrungtam').val(), jQuery('#_listcoso').val());

            jQuery('#_listgiaovien').change(function () {
                calendar.refetchEvents();
            });
        });
        let calendar;
        document.addEventListener('DOMContentLoaded', function () {
            let calendarEl = document.getElementById('calendar');
            var timenow = new Date();
            var dayNames = ['Chủ nhật', 'Thứ 2', 'Thứ 3', 'Thứ 4', 'Thứ 5', 'Thứ 6', 'Thứ 7',];

            calendar = new FullCalendar.Calendar(calendarEl, {
                navLinks: false,
                headerToolbar: {
                    right: 'prev,next',
                    left: 'dayGridMonth,dayGridWeek,dayGridDay',
                    center: 'title'
                },
                initialDate: timenow,
                titleFormat: {
                    year: 'numeric', month: '2-digit', day: '2-digit'
                },
                timeZone: 'Asia/Ho_Chi_Minh',
                locale: 'vi',
                html: true,
                editable: false,
                dayMaxEventRows: true,
                eventColor: '#ffeeba',
                views: {
                    dayGridMonth: {
                        dayHeaderContent: function (arg) {
                            return dayNames[arg.date.getDay()]
                        },
                        dayMaxEventRows: 2
                    },
                    dayGridDay: {
                        dayHeaderContent: function (arg) {
                            return dayNames[arg.date.getDay()]
                        },
                    },
                    dayGridWeek: {
                        dayHeaderContent: function (arg) {
                            return dayNames[arg.date.getDay()] + moment(arg.date).format(' DD/MM');
                        },
                    },

                },
                //events: dataCalendar,
                events: function (info, successCallback, failureCallback) {
                    var fromDate = info.startStr;
                    var toDate = info.endStr;
                    console.log("Load calendar", fromDate, toDate);
                    var teacherId = jQuery('#_listgiaovien').val();
                    if (teacherId !== '') {
                        loadCalendarTeacher(fromDate, toDate, teacherId, (data) => {
                            successCallback(processData(data.data));
                        });
                    } else {
                        loadCalendarTeachers(jQuery('#sltrungtam').val(), jQuery('#_listcoso').val(), fromDate, toDate, (data) => {
                            successCallback(processData(data.data));
                        });
                    }
                },
                eventContent: function (eventInfo) {
                    if (eventInfo.event.extendedProps.customHtml)
                        return { html: eventInfo.event.extendedProps.customHtml }
                }
            });

            calendar.render();
        });
        function loadCalendarTeachers(_idtrungtam, _idbranch, fromDate, toDate, callback) {
			var url = _apiLink + "/calendars/details/teachers?query=true";
            if (rolesinfologin == "admin") {
                if (_idtrungtam == "adminbeekid")
                    url = url + "&adminOwner=true&fromDate=" + fromDate + "&toDate=" + toDate;
                else {
                    if (_idtrungtam != "0" && _idtrungtam != null && _idtrungtam != "") {
                        url = url + "&orgID=" + _idtrungtam;
                        if (_idbranch != "0" && _idbranch != null && _idbranch != "")
                            url = url + "&branch=" + _idbranch;
                    }
                }
            }

            if (fromDate != null && fromDate != undefined && fromDate != "" && toDate != null && toDate != undefined && toDate != "") {
                url = url + "?fromDate=" + fromDate + "&toDate=" + toDate;
            }

            getRequest(url, (data) => {
                callback(data);
            });
        }

        function loadCalendarTeacher(fromDate, toDate, userId, callback) {
            var scope = "teach";
            var url = _apiLink + `/calendars/details/${scope}/${userId}?fromDate=${fromDate}&toDate=${toDate}`;

            getRequest(url, (data) => {
                callback(data);
            });
        }
		
		 loadCalendarAllTeacher();
        function loadCalendarAllTeacher() {
            var url = `/calendars/details/teachers`;
            var ajaxCall = callApiGlobal.getRequestGlobal(url);
            ajaxCall.done((data) => {
                console.log(data);
            });
            ajaxCall.fail((xhr, status, error) => {
                errShow(xhr);
            });
        }

        function loadteachers(_idtrungtam, _idbranch) {
            var url = _apiLink + "/employees?kind=teacher";
            if (rolesinfologin == "admin") {
                if (_idtrungtam == "adminbeekid")
                    url = url + "&adminOwner=true";
                else {
                    if (_idtrungtam != "0" && _idtrungtam != null && _idtrungtam != "") {
                        url = url + "&orgID=" + _idtrungtam;
                        if (_idbranch != "0" && _idbranch != null && _idbranch != "")
                            url = url + "&branch=" + _idbranch;
                    }
                }
            }
            else {
                if (_idbranch != "0" && _idbranch != null && _idbranch != "")
                    url = url + "&branch=" + _idbranch;
            }

            getRequest(url, (data) => {
                listTeacher = data.data;
                jQuery("#_listgiaovien").empty();
                var htmlinport = "<option value=''>Tất cả giáo viên</option>";
                jQuery.each(data.data, function (i, item) {
                    htmlinport += "<option value='" + item._id + "'>" + item.fullname + "</option>";
                });
                jQuery("#_listgiaovien").append(htmlinport);
                jQuery("#_listgiaovien").chosen({
                    no_results_text: "Không tìm thấy nội dung phù hợp !",
                    width: "100%"
                });
                jQuery('#_listgiaovien').trigger("chosen:updated");
            });
        }



        function processData(calendars) {
            calendars.sort((a, b) => compareDate(a, b));
            const eventsList = [];
            calendars.forEach(function (item, i) {
                var html = '';
                var timeAndColor = getTimeAndColor(item.timeStart, item.timeEnd);

                html += `<b>${item.root.data.course.name} - ${item.root.data._class.name}</b><br>`;
                html += `<span>${timeAndColor.time}</span><br>`;
                html += `<b>GV: ${item.user.fullname}</b>`;

                eventsList.push({
                    start: formatDateCalendar(item.date),
                    textColor: '#ffffff',
                    color: `${timeAndColor.color}`,
                    customHtml: html
                });
            });

            return eventsList;
        }

        function getRequest(url, sucessCallback) {

            jQuery.ajax({
                type: "GET",
                url: url,
                headers: { 'Authorization': 'Bearer ' + tokenlogin },
                contentType: "application/json; charset=utf-8",
                data: '',
                dataType: "json",
                success: function (data) {
                    sucessCallback(data);
                },
                error: function (xhr, status, error) {
                    errShow(xhr);
                }
            });
        }

        function getTimeAndColor(timeStart, timeEnd) {
            var obj = { time: '', color: '' };
            obj.time += `${D(timeStart.hour)}:${D(timeStart.minute)} - ${D(timeEnd.hour)}:${D(timeStart.minute)}`;
            if ((timeStart.hour + timeStart.minute / 60) <= 12) {
                obj.time = `Sáng: ${obj.time}`;
                obj.color = '#0bb2d4';
            } else if ((timeStart.hour + timeStart.minute / 60) <= 17) {
                obj.time = `Chiều: ${obj.time}`;
                obj.color = '#0ec9a3';
            } else {
                obj.time = `Tối: ${obj.time}`;
                obj.color = 'rgb(84, 122, 139)';
            }
            return obj;
        }

        function compareDate(a, b) {
            var date1 = getDate(a);
            var date2 = getDate(b);
            return date1 - date2;
        }

        function getDate(obj) {
            var date = new Date(obj.date);
            date.setHours(obj.timeStart.hour);
            date.setMinutes(obj.timeStart.minute);
            return date;
        }

        function formatDateCalendar(date) {
            var date = new Date(date);
            return [D(date.getFullYear()), D(date.getMonth() + 1), D(date.getDate())].join("-");
        }

        function D(J) { return (J < 10 ? '0' : '') + J; };
    </script>
</asp:Content>

